'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbclipper.exe"
#Debug Error On
#Debug Display On
#Dim All
%Unicode=1
#Include "Win32API.inc"
#Resource Icon, logo, "files/gbclipper.ico"
#Resource Icon, xopen, "files/open.ico"
#Resource Icon, xclear, "files/clear.ico"
#Resource Icon, xdelete, "files/delete.ico"
#Resource Icon, xcopy, "files/copy.ico"

#Resource Icon, xpaste, "files/paste.ico"
#Resource Icon, xtray, "files/tray.ico"

#Resource Icon, xautocapture, "files/autocapture.ico"
#Resource Icon, xcontext, "files/context.ico"

#Resource Icon, xsettings, "files/settings.ico"
#Resource Icon, xhelp, "files/help.ico"

#Resource Icon, xuphand, "files/uphand.ico"
#Resource Icon, xdownhand, "files/downhand.ico"

#Resource Icon, xsearch, "files/search.ico"
#Resource Icon, xreload, "files/reload.ico"

$ver = "  v1.14"
$DelimiterA = $CrLf + "-.-.-.-. "  '11
$DelimiterB = "------------------------------------------------------------------" + $CrLf '65

Enum Equates Singular
   IDC_ListView    = 500
   IDC_Toolbar
   IDC_Statusbar

   IDT_Open
   IDT_Clear
   IDT_Paste
   IDT_Tray
   IDT_AutoCapture
   IDT_ShowContext
   IDT_Settings
   IDT_Delete
   IDT_CopyItem
   IDT_Search
   IDT_Reload
   IDT_Help

   IDM_Sep
   IDM_Open
   IDM_Help
   IDM_Clear
   IDM_SysTray
   IDM_Exit
   IDM_AutoCapture
   IDM_Paste
   IDM_AppOnTop
   IDM_Reduce
   IDM_Original
   IDM_OpenPath
   IDM_ShowContext
   IDM_SetContextSize
   IDM_TextWrap
   IDM_WrapLineLength
   IDM_MaxItems
   IDM_MiniMode
   IDM_ShowSelectionA
   IDM_ShowSelectionB
   IDM_CopyItem
   IDM_Reload
   IDM_RecentOnTop
   IDM_DeleteItem
   IDM_SaveAs
   IDM_WrapNow
   IDM_MakeMostRecent
   IDM_Ask
   IDM_Font
   IDM_Unselect
   IDM_ShowCheckBoxes
   IDM_LoadFakeData
   IDM_Debug
   IDM_CheckAll
   IDM_UnCheckAll

   IDS_Label
   IDS_Search
   IDS_SearchTerm
   IDS_SearchSensitive
End Enum

%UniqueNumber = 1717171717
%WM_Tray  = %WM_User + 1

Global FontName, LastDateTime, ViewFile, HistoryFile, ExportFile, SearchTerm  As WStringZ * %Max_Path
Global MinTextLength, BackupCount, TextWrap,WrapLineLength, LastSelected, CaseSensitive, Searching As Long
Global StopCapture, SysTray, AutoCapture,AppOnTop,RecentOnTop,ShowContext,FontSize,FontAttr  As Long
Global ContextSize,MaxItems,OldW,OldH,MiniX,MiniY,Ask,fDlgShown, ShowCheckBoxes  As Long, tn As NotifyIconData
Global hDlg,hNextViewer,hPopupSetting,ghHook,hListView,hPopupListView,hFont,hSearch,Debug,hConsole As Dword
Global History() As WString


Function PBMain() As Long
   If Debug Then cPrint FuncName$
   If InstanceTest Then Exit Function   'will switch to exising instance if one is found

   Dialog New Pixels, 0, "gbClipper " + $ver,505,250,250,200, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg,"logo"
   SetWindowLong(hDlg, %GWL_USERDATA, %UniqueNumber)

   Control Add ListView, hDlg, %IDC_ListView,"", 0,52,200,400, %WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel
   Control Handle hDlg, %IDC_ListView To hListView
   ListView Insert Column hDlg, %IDC_ListView, 1, "Item", 50, 0                   '40/430 =  10%
   ListView Insert Column hDlg, %IDC_ListView, 2, "Content", 210, 0               '210/430 = 49%
   ListView Insert Column hDlg, %IDC_ListView, 3, "# Lines", 60, 0              '60/430 =  13%
   ListView Insert Column hDlg, %IDC_ListView, 4, "Date-Time", 135, 0             '120/430 = 28%

   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0

   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local temp$, w,h,iResult As Long, pt As Point, nmtb As TBNotify Ptr, rc As Rect, P As TooltipText Ptr
   Select Case CbMsg
      Case %WM_InitDialog
         CreateToolbar
         CreatePopupMenus
         Settings_INI "get"
         ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_DoubleBuffer Or IIf(ShowCheckBoxes,%LVS_Ex_CheckBoxes, 0)
         ListView Set Column hDlg, %IDC_ListView, 1, 50 + ShowCheckBoxes * 30
         Font New FontName, FontSize, FontAttr To hFont
         Control Set Font hDlg, %IDC_ListView, hFont
         BuildAcceleratorTable
         If IsFalse(IsFile(HistoryFile)) Then InitializeHistoryFile
         LoadHistoryFile
         LoadListView
         ListView Select hDlg, %IDC_ListView, LastSelected
         SetMenuStatus
         ViewFile = HistoryFile + PathName$(Extn, HistoryFile)
         If AutoCapture Then hNextViewer = SetClipboardViewer(hDlg)    ' add ourselves to the chain of clipboard viewers
         SetOnTop
         ManageSystemTray
         PostMessage hDlg, %WM_User + 500, 0, 0

      Case %WM_User + 500
         ListView Visible hDlg, %IDC_ListView, LastSelected

      Case %WM_CHANGECBCHAIN  ' clipboard viewer chain has changed
         If Debug Then cPrint "WM_ChangeCBChain"
         If Cb.WParam = hNextViewer Then
            hNextViewer = Cb.LParam
         Else
            If hNextViewer Then SendMessage hNextViewer, Cb.Msg, Cb.WParam, Cb.LParam
         End If
      Case %WM_DRAWCLIPBOARD  ' clipboard content has changed
         If Debug Then cPrint "WM_DrawClipBoard"
         If StopCapture = 0 Then
            Clipboard Get Text To temp$
            AppendClipboardToArray
            LoadListView
            HighlightNewestItem
            SaveHistory
            ResizeWindow
         End If
         If hNextViewer Then SendMessage hNextViewer, Cb.Msg, Cb.WParam, Cb.LParam : Function = 1

      Case %WM_Destroy
         ListView Get Select hDlg, %IDC_ListView To LastSelected : LastSelected = Max(LastSelected,1)
         Dialog Get Client hDlg To w,h
         Shell_NotifyIcon %nim_delete, tn
         Settings_INI "save"
         If hNextViewer Then ChangeClipboardChain hDlg, hNextViewer 'remove app from clipboard viewer chain

      Case %WM_Command
         Select Case Cb.Ctl

            Case %IDM_SysTray, %IDT_Tray
               SysTray = SysTray Xor 1
               SetMenuStatus
               ManageSystemTray
            Case %IDT_Open, %IDM_Open
               FileCopy HistoryFile, ViewFile
               iResult = ShellExecute(hDlg, "Open", ViewFile, $Nul, $Nul, %SW_ShowNormal)
            Case %IDT_Paste, %IDM_Paste
               AppendClipboardToArray  'copy current clipboard to history file
               LoadListView
               HighlightNewestItem
               SaveHistory
               ResizeWindow

            Case %IDM_LoadFakeData
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
               If MsgBox ("Are you sure?", %MB_OkCancel Or %MB_IconQuestion, "Load Fake Data") = %IdOk Then LoadFakeData

            Case %IDM_Debug
               Debug = Debug Xor 1

            Case %IDT_Clear, %IDM_Clear
               If UBound(History) Then
                  If Ask Then
                     ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                     If MsgBox ("Are you sure?", %MB_OkCancel Or %MB_IconQuestion, "Clear History File") = %IdOk Then InitializeHistoryFile
                  Else
                     InitializeHistoryFile
                  End If
               End If
            Case %IDM_Reduce
               If UBound(History) > MaxItems Then
                  If Ask Then
                     ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                     If MsgBox ("Are you sure?", %MB_OkCancel Or %MB_IconQuestion, "Reduce History") = %IdOk Then iResult = 1
                  Else
                     iResult = 1
                  End If
                  If iResult Then
                      ListView Get Select hDlg, %IDC_ListView To iResult   'get LV line
                      iResult = HistoryItemNumberContainingLVLine(iResult) 'get History() item containing LV line
                      ReDim Preserve History(MaxItems)
                      LoadListView
                      iResult = Min(iResult, UBound(History))
                      SelectFirstLineOfHistoryItem(iResult)  'select and make visible
                      SaveHistory
                  End If
               End If

            Case %IDT_Delete, %IDM_DeleteItem : DeleteItems

            Case %IDT_AutoCapture, %IDM_AutoCapture
               AutoCapture = AutoCapture Xor 1
               SetMenuStatus
               If AutoCapture Then
                  hNextViewer = SetClipboardViewer(hDlg)    ' add app to the chain of clipboard viewers
               Else
                  If hNextViewer Then ChangeClipboardChain hDlg, hNextViewer 'remove app from clipboard viewer chain
               End If

            Case %IDM_TextWrap
               TextWrap = TextWrap Xor 1
               SetMenuStatus

            Case %IDT_ShowContext, %IDM_ShowContext
               ShowContext = ShowContext Xor 1
               SetMenuStatus
               ListView Get Select hDlg, %IDC_ListView To iResult   'get LV line
               iResult = HistoryItemNumberContainingLVLine(iResult) 'get History() item containing LV line
               LoadListView
               SelectFirstLineOfHistoryItem(iResult)  'select and make visible

            Case %IDT_Settings, %IDM_RecentOnTop
               RecentOnTop = RecentOnTop Xor 1
               SetMenuStatus
               LoadListView
               HighlightNewestItem

            Case %IDT_Search
               DisplayFindDialog

            Case %IDT_Reload, %IDM_Reload    'Ctl-R
               LoadHistoryFile
               If UBound(History) Then
                  LoadListView
                  HighlightNewestItem
                  ResizeWindow
               End If

            Case %IDT_Help,%IDM_Help
                 temp$ = "http://www.garybeene.com/sw/gbclipper.htm"
                 iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            'Case %IDM_Open (see above)
            'Case %IDM_Capture (see above)
            'Case %IDM_Clear (see above)
            'Case %IDM_Reduce (see above)
            Case %IDM_SetContextSize
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("", "Context Size", Str$(ContextSize),w+40,h+150)
               If Len(temp$) Then ContextSize = Val(temp$)
               If ShowContext Then
                  ListView Get Select hDlg, %IDC_ListView To iResult   'get LV line
                  iResult = HistoryItemNumberContainingLVLine(iResult) 'get History() item containing LV line
                  LoadListView
                  SelectFirstLineOfHistoryItem(iResult)  'select and make visible
               End If

            Case %IDM_MaxItems
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("", "Reduce History Count", Str$(MaxItems),w+40,h+150)
               If Len(temp$) Then MaxItems = Val(temp$)
            Case %IDM_WrapLineLength
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("", "Wrap Line Length", Str$(WrapLineLength),w+40,h+150)
               If Len(temp$) Then WrapLineLength = Val(temp$)
            'Case %IDM_Settings (see above
            'Case %IDM_Tray (see above)
            'Case %IDM_AutoCapture (see above)
            Case %IDM_AppOnTop
               AppOnTop = AppOnTop Xor 1
               SetMenuStatus
               SetOnTop
            'Case %IDM_ShowContext (see above)
            'Case %IDM_TextWrap (see above)
            Case %IDM_Ask
               Ask = Ask Xor 1
               SetMenuStatus
            'Case %IDM_Settings (see above)
            'Case %IDM_Help (see above)
            Case %IDM_Exit : Dialog End hDlg

            Case %IDM_ShowCheckBoxes
               ShowCheckBoxes = ShowCheckBoxes Xor 1
               ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_DoubleBuffer Or IIf(ShowCheckBoxes,%LVS_Ex_CheckBoxes, 0)
               ListView Set Column hDlg, %IDC_ListView, 1, 50 + ShowCheckBoxes * 30
               ResizeWindow
               SetMenuStatus
               ResizeWindow

            Case %IDM_CheckAll   :  CheckAll(1)
            Case %IDM_UncheckAll :  CheckAll(0)

            Case %IDM_ShowSelectionA
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult Then
                  temp$ = HistoryItemTextContainingLVLine(iResult)
                  Open Exe.Path$ + "temp.txt" For Output As #1
                  Print #1, temp$;
                  Close #1
                  iResult = Shell("notepad.exe temp.txt" , 1)   'does not wait
               End If

            Case %IDM_ShowSelectionB
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult Then
                  MsgBox HistoryItemTextContainingLVLine(iResult), %MB_Ok + %MB_IconInformation, "History Item"
               End If

            Case %IDM_OpenPath
               ListView Get Select hDlg, %IDC_ListView To iResult
               ListView Get Text hDlg, %IDC_Listview, iResult,2 To temp$
               ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_CopyItem, %IDT_CopyItem       : CopyToClipboard

            Case %IDM_SaveAs                        : SaveAs

            Case %IDM_WrapNow
               WrapNow
               ListView Get Select hDlg, %IDC_ListView To iResult   'get LV line
               iResult = HistoryItemNumberContainingLVLine(iResult) 'get History() item containing LV line
               LoadListView
               SelectFirstLineOfHistoryItem(iResult)  'select and make visible
               SaveHistory

            Case %IDM_MakeMostRecent
               MakeMostRecent
               LoadListView
               HighlightNewestItem

            Case %IDM_Font
               SelectMainFont
               Control Set Font hDlg, %IDC_ListView, hFont
               ResizeWindow

'Available only thru accelerator keys
            Case %IDM_MiniMode  'Ctl-M
               SetMiniMode

            Case %IDM_Original  'Ctl-E
               iResult = ShellExecute(hDlg, "Open", HistoryFile, $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_UnSelect
               ListView Get Select hDlg, %IDC_ListView To iResult
               ListView Unselect hDlg, %IDC_ListView, iResult

         End Select

      Case %WM_Size : ResizeWindow

      Case %WM_NCLButtonDblClk
         Dialog Get Loc hDlg To w,h
         If w>0 And h>0 Then SetMiniMode : Function = 1 : Exit Function 'takes into account maximized status

      Case %WM_ContextMenu
         w = Lo(Integer,Cb.LParam) : h = Hi(Integer, Cb.LParam)
         iResult = GetDlgCtrlID (Cb.WParam)             'get control ID
         Select Case iResult
            Case %IDC_ListView
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult Then TrackPopupMenu hPopupListView, %TPM_LeftAlign, w, h, 0, Cb.Hndl, ByVal 0
         End Select

      Case %WM_Tray
         Select Case Cb.LParam
            Case %WM_RButtonDown
               Menu Set Text hPopupSetting, ByCmd %IDM_SetContextSize, "Set Context Size (" + Str$(ContextSize) + ")"
               Menu Set Text hPopupSetting, ByCmd %IDM_MaxItems, "Set Reduce History Item Count (" + Str$(MaxItems) + ")"
               Menu Set Text hPopupSetting, ByCmd %IDM_WrapLineLength, "Set Wrap Line Length (" + Str$(WrapLineLength) + ")"
               GetCursorPos pt
               TrackPopupMenu hPopupSetting, %TPM_BottomAlign Or %TPM_RightAlign, pt.x, pt.y, 0, hDlg, ByVal %null
               PostMessage hDlg, %WM_Null, 0, 0
            Case %WM_LButtonDblClk
               SysTray = SysTray Xor 1
               SetMenuStatus
               ManageSystemTray
         End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Menu Set Text hPopupSetting, ByCmd %IDM_SetContextSize, "Set Context Size (" + Str$(ContextSize) + ")"
                       Menu Set Text hPopupSetting, ByCmd %IDM_MaxItems, "Set Reduce History Item Count (" + Str$(MaxItems) + ")"
                       Menu Set Text hPopupSetting, ByCmd %IDM_WrapLineLength, "Set Wrap Line Length (" + Str$(WrapLineLength) + ")"
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupSetting, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_Open To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
               Case %IDC_ListView
                  Select Case Cb.NmCode
                     Case %NM_DblClk
                        ListView Get Select hDlg, %IDC_ListView To iResult
                        If iResult Then MsgBox HistoryItemTextContainingLVLine(iResult), %MB_Ok + %MB_IconInformation, "History Item"
                  End Select
         End Select

   End Select
End Function

Sub Settings_INI(Task$)
   If Debug Then cPrint FuncName$
   Local x,y As Long, xResult, yResult, INIFileName, tempz As WStringZ * %Max_Path
   INIFileName = Exe.Path$ + "gbclipper.ini"
   'set ini filename
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "620", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "250", yResult, %Max_Path, INIFileName
      Dialog Set Client hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "HistoryFile", Exe.Path$ + "history.txt", tempz, %Max_Path, INIFileName : HistoryFile = tempz
      Getprivateprofilestring "All", "LastDateTime", Date$ + "  " + Time$, tempz, %Max_Path, INIFileName : LastDateTime = tempz
      Getprivateprofilestring "All", "ExportFile", Exe.Path$ + "history_item.txt", tempz, %Max_Path, INIFileName : ExportFile = tempz
      Getprivateprofilestring "All", "FontName", "MS Sans Serif", tempz, %Max_Path, INIFileName : FontName = tempz
      Getprivateprofilestring "All", "SearchTerm", "", tempz, %Max_Path, INIFileName : SearchTerm = tempz
      'get value for numeric variables
      Getprivateprofilestring "All", "CaseSensitive", "0", tempz, %Max_Path, INIFileName:  CaseSensitive = Val(tempz)
      Getprivateprofilestring "All", "LastSelected", "1", tempz, %Max_Path, INIFileName:  LastSelected = Val(tempz)
      Getprivateprofilestring "All", "MiniX", "170", tempz, %Max_Path, INIFileName:  MiniX = Val(tempz)
      Getprivateprofilestring "All", "MiniY", "70", tempz, %Max_Path, INIFileName:  MiniY = Val(tempz)
      Getprivateprofilestring "All", "BackupCount", "10", tempz, %Max_Path, INIFileName:  BackupCount = Val(tempz)
      Getprivateprofilestring "All", "SysTray", "0", tempz, %Max_Path, INIFileName:  SysTray = Val(tempz)
      Getprivateprofilestring "All", "AutoCapture", "1", tempz, %Max_Path, INIFileName:  AutoCapture = Val(tempz)
      Getprivateprofilestring "All", "AppOnTop", "0", tempz, %Max_Path, INIFileName:  AppOnTop = Val(tempz)
      Getprivateprofilestring "All", "Ask", "1", tempz, %Max_Path, INIFileName:  Ask = Val(tempz)
      Getprivateprofilestring "All", "RecentOnTop", "0", tempz, %Max_Path, INIFileName:  RecentOnTop = Val(tempz)
      Getprivateprofilestring "All", "MinTextLength", "0", tempz, %Max_Path, INIFileName:  MinTextLength = Val(tempz)
      Getprivateprofilestring "All", "ContextSize", "5", tempz, %Max_Path, INIFileName:  ContextSize = Val(tempz)
      Getprivateprofilestring "All", "ShowContext", "0", tempz, %Max_Path, INIFileName:  ShowContext = Val(tempz)
      Getprivateprofilestring "All", "TextWrap", "0", tempz, %Max_Path, INIFileName:  TextWrap = Val(tempz)
      Getprivateprofilestring "All", "MaxItems", "10", tempz, %Max_Path, INIFileName:  MaxItems = Val(tempz)
      Getprivateprofilestring "All", "OldW", "620", tempz, %Max_Path, INIFileName:  OldW = Val(tempz)
      Getprivateprofilestring "All", "OldH", "250", tempz, %Max_Path, INIFileName:  OldH = Val(tempz)
      Getprivateprofilestring "All", "WrapLineLength", "80", tempz, %Max_Path, INIFileName:  WrapLineLength = Val(tempz)
      Getprivateprofilestring "All", "FontSize", "8", tempz, %Max_Path, INIFileName:  FontSize = Val(tempz)
      Getprivateprofilestring "All", "FontAttr", "0", tempz, %Max_Path, INIFileName:  FontAttr = Val(tempz)
      Getprivateprofilestring "All", "ShowCheckBoxes", "0", tempz, %Max_Path, INIFileName:  ShowCheckBoxes = Val(tempz)
      Getprivateprofilestring "All", "Debug", "0", tempz, %Max_Path, INIFileName:  Debug = Val(tempz)
   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Client hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "HistoryFile",HistoryFile, INIFileName
      WritePrivateProfileString "All", "LastDateTime",LastDateTime, INIFileName
      WritePrivateProfileString "All", "ExportFile",ExportFile, INIFileName
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "CaseSensitive", (Str$(CaseSensitive)), INIFileName
      WritePrivateProfileString "All", "LastSelected", (Str$(LastSelected)), INIFileName
      WritePrivateProfileString "All", "BackupCount", (Str$(BackupCount)), INIFileName
      WritePrivateProfileString "All", "SysTray", (Str$(SysTray)), INIFileName
      WritePrivateProfileString "All", "AutoCapture", (Str$(AutoCapture)), INIFileName
      WritePrivateProfileString "All", "AppOnTop", (Str$(AppOnTop)), INIFileName
      WritePrivateProfileString "All", "Ask", (Str$(Ask)), INIFileName
      WritePrivateProfileString "All", "RecentOnTop", (Str$(RecentOnTop)), INIFileName
      WritePrivateProfileString "All", "MinTextLength", (Str$(MinTextLength)), INIFileName
      WritePrivateProfileString "All", "ContextSize", (Str$(ContextSize)), INIFileName
      WritePrivateProfileString "All", "ShowContext", (Str$(ShowContext)), INIFileName
      WritePrivateProfileString "All", "TextWrap", (Str$(TextWrap)), INIFileName
      WritePrivateProfileString "All", "MaxItems", (Str$(MaxItems)), INIFileName
      WritePrivateProfileString "All", "OldW", (Str$(OldW)), INIFileName
      WritePrivateProfileString "All", "OldH", (Str$(OldH)), INIFileName
      WritePrivateProfileString "All", "WrapLineLength", (Str$(WrapLineLength)), INIFileName
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "ShowCheckBoxes", (Str$(ShowCheckBoxes)), INIFileName
      WritePrivateProfileString "All", "Debug", (Str$(Debug)), INIFileName
   End If
End Sub


Sub ResizeWindow
   If Debug Then cPrint FuncName$
   Local w,h As Long, i,j,k As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_ListView, w,h-70
'   ListView Set Column hDlg, %IDC_ListView, 1, 50 + ShowCheckBoxes * 30
'   ListView Set Column hDlg, %IDC_ListView, 2, w - 50 - ShowCheckBoxes * 30 - 60 - 135  _
'                    + 18 * IsTrue(GetWindowLong(hListView, %GWL_STYLE) And %WS_VScroll)
   ListView Set Column hDlg, %IDC_ListView, 1, -2
   ListView Set Column hDlg, %IDC_ListView, 3, -2
   ListView Get Column hDlg, %IDC_ListView, 1 To i
   ListView Get Column hDlg, %IDC_ListView, 3 To j

   ListView Set Column hDlg, %IDC_ListView, 2, 9999
   ListView Set Column hDlg, %IDC_ListView, 4, -2
   ListView Get Column hDlg, %IDC_ListView, 4 To k
   ListView Set Column hDlg, %IDC_ListView, 2, w - i - j - k - 18 * IsTrue(GetWindowLong(hListView, %GWL_STYLE) And %WS_VScroll)

End Sub

Sub InitializeHistoryFile
   If Debug Then cPrint FuncName$
   Open HistoryFile For Output As #1 : Close #1
   ReDim History(0)
   ListView Reset hDlg, %IDC_ListView
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Items: 0"
End Sub

Sub SetMenuStatus
   If Debug Then cPrint FuncName$
   'Toolbar Buttons
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AutoCapture, %TBState_Checked * AutoCapture Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowContext, %TBState_Checked * ShowContext Or %TBState_Enabled

   'Popup Menus
   Menu Set State hPopupSetting, ByCmd %IDM_SysTray, SysTray * (%MFS_Checked Or %MFS_Enabled)
   Menu Set State hPopupSetting, ByCmd %IDM_AutoCapture, AutoCapture * (%MFS_Checked Or %MFS_Enabled)
   Menu Set State hPopupSetting, ByCmd %IDM_AppOnTop, AppOnTop * (%MFS_Checked Or %MFS_Enabled)
   Menu Set State hPopupSetting, ByCmd %IDM_RecentOnTop, RecentOnTop * (%MFS_Checked Or %MFS_Enabled)
   Menu Set State hPopupSetting, ByCmd %IDM_ShowContext, ShowContext * (%MFS_Checked Or %MFS_Enabled)
   Menu Set State hPopupSetting, ByCmd %IDM_TextWrap, TextWrap * (%MFS_Checked Or %MFS_Enabled)
   Menu Set State hPopupSetting, ByCmd %IDM_Ask, Ask * (%MFS_Checked Or %MFS_Enabled)
   Menu Set State hPopupSetting, ByCmd %IDM_ShowCheckBoxes, ShowCheckBoxes * (%MFS_Checked Or %MFS_Enabled)

   'CheckBox (Search Dialog)
   Control Set Check hSearch, %IDS_SearchSensitive, CaseSensitive

End Sub

Sub ManageSystemTray
   If Debug Then cPrint FuncName$
   If SysTray Then
      Dialog Show State hDlg, %SW_Hide
      tn.cbsize = SizeOf(tn)
      tn.hwnd   = hDlg
      tn.uid    =  GetModuleHandle(ByVal %NULL)   'g_hinst
      tn.uflags = %nif_icon Or %nif_message Or %nif_tip
      tn.ucallbackmessage = %WM_Tray
      tn.hicon = loadicon(GetModuleHandle(""),"logo" )
      tn.sztip = "gbClipper"
      Shell_NotifyIcon %nim_add, tn
   Else
      Shell_NotifyIcon %nim_delete, tn
      Dialog Show State hDlg, %SW_Show  ' or %SW_Minimize
   End If
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Dialog Get Loc hDlg To x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x+75, y+75, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub BuildAcceleratorTable
   If Debug Then cPrint FuncName$
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(10)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDM_Help          : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3 : ac(c).cmd   = %IDT_Search        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D  : ac(c).cmd   = %IDM_Debug         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E  : ac(c).cmd   = %IDM_Original      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F  : ac(c).cmd   = %IDT_Search        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M  : ac(c).cmd   = %IDM_MiniMode      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R  : ac(c).cmd   = %IDM_Reload        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S  : ac(c).cmd   = %IDM_SysTray       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_U  : ac(c).cmd   = %IDM_Unselect      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_X  : ac(c).cmd   = %IDM_Exit          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L  : ac(c).cmd   = %IDM_LoadFakeData  : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub SetOnTop
   If Debug Then cPrint FuncName$
   Local iReturn As Integer, Flags&
   FLAGS = %SWP_NOMOVE Or %SWP_NOSIZE
   If AppOnTop Then
      iReturn = SetWindowPos(hDlg, %HWND_TOPMOST, 0, 0, 0, 0, Flags)  'on Top
   Else
      iReturn = SetWindowPos(hDlg, %HWND_NOTOPMOST, 0, 0, 0, 0, Flags) 'not on Top
   End If
End Sub

Function InputBoxProcExt(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
'      If UCase$(szTemp) = "BUTTON" Then @cst.cx = @cst20                           'prompt
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 75                           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.y = -50 : @cst.cx = 0  : @cst.cy = 20           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 50 : @cst.y = @cst.y - 140  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 175 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub CreateToolbar
   If Debug Then cPrint FuncName$
    Local hImageList,hToolbar As Dword
    ImageList New Icon 24,24,24,20 To hImageList
    ImageList Add Icon hImageList, "xopen"      '1
    ImageList Add Icon hImageList, "xclear"     '2
    ImageList Add Icon hImageList, "xpaste"     '3
    ImageList Add Icon hImageList, "xtray"      '4

    ImageList Add Icon hImageList, "xautocapture"   '5
    ImageList Add Icon hImageList, "xcontext"   '6

    ImageList Add Icon hImageList, "xsettings"  '7
    ImageList Add Icon hImageList, "xhelp"      '8

    ImageList Add Icon hImageList, "xdelete"    '9
    ImageList Add Icon hImageList, "xcopy"      '10
    ImageList Add Icon hImageList, "xsearch"    '11
    ImageList Add Icon hImageList, "xreload"    '12

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist

    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Tray,  %TbStyle_Button, "Tray"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Open,  %TbStyle_Button, "Open"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Clear,  %TbStyle_Button, "Clear"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_CopyItem,  %TbStyle_Button, "Copy"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Paste,  %TbStyle_Button, "Paste"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Delete,  %TbStyle_Button, "Delete"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_AutoCapture,  %TbStyle_Check, "AutoCapture"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_ShowContext,  %TbStyle_Check, "Context"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Search,  %TbStyle_Button, "Search"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Reload,  %TbStyle_Button, "Reload"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Help,  %TbStyle_Button, "Help"
End Sub

Sub CreatePopupMenus
   If Debug Then cPrint FuncName$
    Menu New PopUp To hPopupListView
    Menu Add String, hPopupListView, "Copy History Item to Clipboard",  %IDM_CopyItem,  %MF_Enabled
    Menu Add String, hPopupListView, "Save History Item As ...",  %IDM_SaveAs,  %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "Delete History Item",  %IDM_DeleteItem,  %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "Wrap History Item Now",  %IDM_WrapNow,  %MF_Enabled
    Menu Add String, hPopupListView, "Make Most Recent",  %IDM_MakeMostRecent,  %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "View History Item in MsgBox",  %IDM_ShowSelectionB,  %MF_Enabled
    Menu Add String, hPopupListView, "View History Item in Default Text Client",  %IDM_ShowSelectionA,  %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "Open Path",  %IDM_OpenPath,  %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled

    Menu New PopUp To hPopupSetting
    Menu Add String, hPopupSetting, "System Tray",  %IDM_SysTray,  %MF_Enabled
    Menu Add String, hPopupSetting, "AutoCapture",  %IDM_AutoCapture,  %MF_Enabled
    Menu Add String, hPopupSetting, "Show Context Lines",  %IDM_ShowContext,  %MF_Enabled
    Menu Add String, hPopupSetting, "Application On Top",  %IDM_AppOnTop,  %MF_Enabled
    Menu Add String, hPopupSetting, "Ask Before Clear/Reduce/Delete",  %IDM_Ask,  %MF_Enabled
    Menu Add String, hPopupSetting, "Most Recent On Top",  %IDM_RecentOnTop,  %MF_Enabled
    Menu Add String, hPopupSetting, "Wrap Long Lines As Received",  %IDM_TextWrap,  %MF_Enabled
    Menu Add String, hPopupSetting, "Show CheckBoxes",  %IDM_ShowCheckBoxes,  %MF_Enabled
    Menu Add String, hPopupSetting, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSetting, "Check All",  %IDM_CheckAll,  %MF_Enabled
    Menu Add String, hPopupSetting, "UnCheck All",  %IDM_UnCheckAll,  %MF_Enabled
    Menu Add String, hPopupSetting, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSetting, "Open Copy of History File",  %IDM_Open,  %MF_Enabled
    Menu Add String, hPopupSetting, "Clear History",  %IDM_Clear,  %MF_Enabled
    Menu Add String, hPopupSetting, "Paste Clipboard Content",  %IDM_Paste,  %MF_Enabled
    Menu Add String, hPopupSetting, "Reduce History",  %IDM_Reduce,  %MF_Enabled
'    Menu Add String, hPopupSetting, "Create Fake Data",  %IDM_LoadFakeData,  %MF_Enabled
    Menu Add String, hPopupSetting, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSetting, "Select Font",  %IDM_Font,  %MF_Enabled
    Menu Add String, hPopupSetting, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSetting, "Set Context Size",  %IDM_SetContextSize,  %MF_Enabled
    Menu Add String, hPopupSetting, "Set Reduce History Count",  %IDM_MaxItems,  %MF_Enabled
    Menu Add String, hPopupSetting, "Set Wrap Line Length",  %IDM_WrapLineLength,  %MF_Enabled
    Menu Add String, hPopupSetting, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSetting, "Online Help",  %IDM_Help,  %MF_Enabled
    Menu Add String, hPopupSetting, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSetting, "Exit",  %IDM_Exit,  %MF_Enabled
End Sub

Function SetToolTips(cID As Long) As String
   If Debug Then cPrint FuncName$
   Select Case cID          'or this:   @P.hdr.idFrom
      Case %IDT_Tray          : Function = "Send gbClipper to System Tray"
      Case %IDT_Open          : Function = "Open Copy of History File"
      Case %IDT_Paste         : Function = "Place Clipboard Content into History File"
      Case %IDT_Clear         : Function = "Clear History File"
      Case %IDT_CopyItem
         If ShowCheckBoxes Then
            Function = "Copy Checked History Item(s) to Clipboard"
         Else
            Function = "Copy Selected History Item to Clipboard"
         End If
      Case %IDT_Delete
         If ShowCheckBoxes Then
             Function = "Delete Checked History Item(s)"
         Else
             Function = "Delete Selected History Item"
         End If
      Case %IDT_AutoCapture   : Function = "AutoCapture Clipboard Changes to History Files"
      Case %IDT_ShowContext   : Function = "Show Context Lines"
      Case %IDT_Settings
         If RecentOnTop Then
            Function = "Show Most Recent History Item at Bottom of List"
         Else
            Function = "Show Most Recent History Item at Top of List"
         End If
      Case %IDT_Search        : Function = "Search History Items"
      Case %IDT_Reload        : Function = "Restore All History Items (Use After a Search)"
      Case %IDT_Help          : Function = "Open OnLine Help"
   End Select
End Function

Sub SetMiniMode
   If Debug Then cPrint FuncName$
   Local w,h As Long
   'if user resized
   Dialog Get Client hDlg To w,h
   If w <> MiniX And h <> MiniY Then
      OldW = w : OldH = h
      Dialog Set Client hDlg,MiniX,MiniY
   Else
      Dialog Set Client hDlg, OldW, OldH
   End If
End Sub

Function WrapText(ByVal temp$, MaxChar As Long) As String
   Local result$,tmp$
   Do
      Split Word temp$, MaxChar To tmp$, temp$             'tmp$ has <= MaxChar, temp$ has all else
      If Len(tmp$) = 0 Then Function = temp$ : Exit Loop   'needed in case no word break found by MaxChar
      result$ = result$ + $CrLf + LTrim$(tmp$)             'accumulate tmp$ until there's no more temp$
   Loop While Len(temp$)
   Function = LTrim$(result$,$CrLf) + IIf$(Len(temp$),$CrLf + LTrim$(temp$),"")
End Function


Function HistoryItemNumberContainingLVLine(LVLine As Long) As Long  'LVLine is line # within ListView
   If Debug Then cPrint FuncName$
   'get History Item # associated with given line in ListView
   Local temp$
   Incr LVLine
   Do
      Decr LVLine
      ListView Get Text hDlg, %IDC_ListView, LVLine, 1 To temp$
   Loop Until Len(temp$)
   Function = Val(temp$)   'iCount is the History Item #
End Function

Function HistoryItemTextContainingLVLine(LVLine As Long) As String
   If Debug Then cPrint FuncName$
   'gets History() text associated with given line in ListView
   Local i As Long
   'returns History() without Date-Time + $DelimiterB
   i = HistoryItemNumberContainingLVLine(LVLine)   'Get position in History() array of parent to LVLine
   Function = Mid$(History(i), InStr(History(i),$CrLf)+2)
End Function

Sub SaveAs
   If Debug Then cPrint FuncName$
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, iResult&, temp$
    ListView Get Select hDlg, %IDC_ListView To iResult&  'SaveAs saves selected history item - no selection, no save
    If iResult& = 0 Then Exit Sub
    title$ = ""                'caption title. if "", then "Save As" is displayed
    startfolder$ = ExportFile  'initial folder to be displayed
    filter$ = "Text Files" + $Nul + ".txt" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfile$ = ExportFile    'name to be used as initial selection
    defaultext$ = "txt"        'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       temp$ = HistoryItemTextContainingLVLine(iResult&)
       Open filevar$ For Output As #1
       Print #1, temp$;
       Close #1
    End If
End Sub

Sub WrapNow
   If Debug Then cPrint FuncName$
   Local L$,R$,LVLine,HistoryItem As Long
   ListView Get Select hDlg, %IDC_ListView To LVLine  'line number in ListView
   If LVLine = 0 Then Exit Sub
   HistoryItem = HistoryItemNumberContainingLVLine(LVLine)                    'History Item #
   '---------------------------------------
   L$ = Left$(History(HistoryItem), InStr(History(HistoryItem),$CrLf)+1)
   R$ = Mid$(History(HistoryItem), InStr(History(HistoryItem),$CrLf)+2)
   Replace $CrLf With $Spc In R$
   History(HistoryItem) = L$ + WrapText (R$,WrapLineLength)
   '---------------------------------------
End Sub

Sub SaveHistory
   If Debug Then cPrint FuncName$
   'History() elements include Date$-Time$ + $DelimiterB
   '$DelimiterA only appears in the history file (history.txt)
   Open HistoryFile For Output As #1 : Print #1, Join$(History(),$DelimiterA); : Close #1
   If (UBound(History) Mod BackupCount) = 0 Then FileCopy HistoryFile, HistoryFile + ".bak"
End Sub

Sub MakeMostRecent
   If Debug Then cPrint FuncName$
   Local LVLine,HistoryItem As Long
   ListView Get Select hDlg, %IDC_ListView To LVLine  'line number in ListView
   If LVLine = 0 Then Exit Sub
   HistoryItem = HistoryItemNumberContainingLVLine(LVLine)                    'History Item #
   '---------------------------------------
   Array Delete History(HistoryItem), History(HistoryItem)
   '---------------------------------------
End Sub

Sub DeleteSelectedItem
   If Debug Then cPrint FuncName$
   Local LVLine,HistoryItem As Long
   ListView Get Select hDlg, %IDC_ListView To LVLine  'line number in ListView
   If LVLine = 0 Then Exit Sub

   'remove selected item from array
   HistoryItem = HistoryItemNumberContainingLVLine(LVLine)                    'History Item #
   '---------------------------------------
   Array Delete History(HistoryItem)
   ReDim Preserve History(UBound(History)-1)
   '---------------------------------------
End Sub

Sub SelectMainFont
   If Debug Then cPrint FuncName$
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or %CF_FixedPitchOnly
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub AppendClipboardToArray
   If Debug Then cPrint FuncName$
   Local iResult As Long, temp$

   'get clipboard text - exit sub if no text or text too small
   Clipboard Get Text temp$, iResult
   If iResult    = 0 Then Exit Sub
   If Len(temp$) = 0 Then Exit Sub
   If Len(temp$) < MinTextLength Then Exit Sub

   'wrap text as required
   If TextWrap Then Replace $CrLf With " " In temp$ : temp$ = WrapText(temp$,WrapLineLength)

   'if History file does not exist, create an empty one
   If IsFalse(IsFile(HistoryFile)) Then InitializeHistoryFile

   'add to end of array. back up if count exceeds MaxCoutner
   ReDim Preserve History(UBound(History)+1)
   LastDateTime = Date$ + "  " + Time$
   History(UBound(History)) = LastDateTime + $DelimiterB + temp$
End Sub

Sub LoadHistoryFile
   If Debug Then cPrint FuncName$
   MousePtr 11
   Local temp$
   'put clipboard history into a string array
   Open HistoryFile For Binary As #1 : Get$ #1, Lof(1), temp$ : Close #1
   If Len(temp$) = 0 Then
      ReDim History(0)
      Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Items: 0"
   Else
      ReDim History(ParseCount(temp$,$DelimiterA) - 1) 'zero position is not used because 1st line of Hist file starts with $delimiterA
      Parse temp$, History(),$DelimiterA               'zero position will be empty
   End If
   MousePtr 1
End Sub

Sub LoadListView   'also searches
   If Debug Then cPrint FuncName$
   MousePtr 11
   Local i,j,iRow,iEnd As Long, sTerm As String
   Dim txtLines() As String
   ListView Reset hDlg, %IDC_ListView

   If Searching Then
      Control Get Text hSearch, %IDS_SearchTerm To sTerm
      If CaseSensitive = 0 Then sTerm = LCase$(sTerm)
   End If

   'put each item into ListView
   For i = 1 To UBound(History)
      j = ParseCount(History(i),$CrLf)-1

      If Searching Then
         'display on History items that contain sTerm
         If CaseSensitive Then
            If InStr(History(i),sTerm)=0 Then Iterate For
         Else
            If InStr(LCase$(History(i)),sTerm)=0 Then Iterate For
         End If
      End If

      ReDim txtLines(j)
      LastDateTime = Left$(History(i),20)
      Parse History(i),txtLines(),$CrLf   'zero position is not used (contains header)
      'add to ListView (end or front, depending on RecentOnTop)
      If RecentOnTop Then iRow = 0
      If ShowContext Then iEnd = Min(ContextSize, UBound(txtLines)) Else iEnd = 1
      For j = 1 To iEnd
         Incr iRow
         If j = 1 Then
            ListView Insert Item hDlg, %IDC_ListView, iRow, 0, Str$(i)
            ListView Set Text hDlg, %IDC_ListView, iRow, 3, Str$(UBound(txtLines))
            ListView Set Text hDlg, %IDC_ListView, iRow, 4, LastDateTime
         Else
            ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""
         End If
         ListView Set Text hDlg, %IDC_ListView, iRow, 2, txtLines(j)
      Next j
   Next i

   LastDateTime = Left$(History(UBound(History)),20)
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Items: " + Str$(UBound(History)) + "   " + LastDateTime
   MousePtr 1
End Sub

Sub HighlightNewestItem
   If Debug Then cPrint FuncName$
   Local iResult As Long
   If RecentOnTop Then
      ListView Select hDlg, %IDC_ListView, 1
      ListView Visible hDlg, %IDC_ListView,1
   Else
      ListView Get Count hDlg, %IDC_ListView To iResult  'last line in ListView
      SelectFirstLineofHistoryItemContainingLVLine iResult
   End If
End Sub

Sub SelectFirstLineOfHistoryItemContainingLVLine(LVLine As Long)
   If Debug Then cPrint FuncName$
   'selects 1st line of history item containing given line in ListView
   Local temp$
   Incr LVLine
   Do
      Decr LVLine
      ListView Get Text hDlg, %IDC_ListView, LVLine, 1 To temp$
   Loop Until Len(temp$)
   ListView Select hDlg, %IDC_ListView, LVLine
   ListView Visible hDlg, %IDC_ListView,LVLine
End Sub

Sub SelectFirstLineOfHistoryItem(HistoryItem As Long)
   If Debug Then cPrint FuncName$
   Local i,iCount As Long, temp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, i, 1 To temp$
      If HistoryItem = Val(temp$) Then
         ListView Select hDlg, %IDC_ListView, i
         ListView Visible hDlg, %IDC_ListView, i
         Exit For
      End If
   Next i
End Sub

Sub DisplayFindDialog()
   If Debug Then cPrint FuncName$
   Local h As Long, w As Long
   Dialog Get Client hDlg To h,w
   Dialog New Pixels, hDlg, "Search", 300, 100, 330, 75, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hSearch
   Dialog Set Icon hSearch, "logo"

   Control Add CheckBox, hSearch, %IDS_SearchSensitive, "Case Sensitive", 60,45,100,20
   SetMenuStatus
   Control Add Label, hSearch, %IDS_Label, "Find This:", 5, 10, 60, 20
   Control Add TextBox, hSearch, %IDS_SearchTerm, SearchTerm, 60, 10, 185, 20
   Control Add Button, hSearch, %IDS_Search, "Search", 260, 10, 50, 25

   Control Add Button, hSearch, %IdOk, "Ok", 200, 230, 20, 20
   Control Add Button, hSearch, %IdCancel, "Cancel", 230, 230, 20, 20
   Control Show State hSearch, %IdOk, %SW_Hide
   Control Show State hSearch, %IdCancel, %SW_Hide

   fDlgShown = 1

   Dialog Show Modeless hSearch Call SearchProc()
   Do                                                                    'because we want to be able
      Dialog DoEvents                                                     'to edit main text while
   Loop Until fDlgShown = 0

End Sub

CallBack Function SearchProc() As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Control Set Focus hSearch, %IDS_SearchTerm
         Control Send hSearch, %IDS_SearchTerm, %EM_SETSEL, 0, -1
      Case %IdCancel
         fDlgShown = 0
         Dialog End hSearch
      Case %WM_Destroy
         fDlgShown = 0
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdCancel
               Dialog End hSearch
            Case %IDS_Search, %IdOk    'search forward
               Control Get Text hSearch, %IDS_SearchTerm To SearchTerm
               If Len(SearchTerm) Then Searching = 1 : LoadListView : Searching = 0
               Control Set Focus hSearch, %IDS_SearchTerm
               Control Send hSearch, %IDS_SearchTerm, %EM_SETSEL, 0, -1

            Case %IDS_SearchSensitive
               CaseSensitive = CaseSensitive Xor 1
               SetMenuStatus
         End Select
   End Select
End Function

Sub LoadFakeData
   If Debug Then cPrint FuncName$
   MousePtr 11
   InitializeHistoryFile
   StopCapture = 1
   Clipboard Reset : Clipboard Set Text "This is the first line" : AppendClipboardToArray
   Clipboard Reset : Clipboard Set Text "Now is the time for another" : AppendClipboardToArray
   Clipboard Reset : Clipboard Set Text "Are we there yet, daddy" : AppendClipboardToArray
   Clipboard Reset : Clipboard Set Text "Scoot along little doggie" : AppendClipboardToArray
   Clipboard Reset : Clipboard Set Text "It is hammer time" : AppendClipboardToArray
   StopCapture = 0
   LoadListView
   HighlightNewestItem
   SaveHistory
   ResizeWindow
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Items: " + Str$(UBound(History)) + "   " + LastDateTime
   MousePtr 1
End Sub

Sub CopyToClipboard
   If Debug Then cPrint FuncName$
   Local iResult,i,iCount As Long, temp$, tmp$
   If ShowCheckBoxes Then
      ListView Get Count hDlg, %IDC_ListView To iCount
      For i = 1 To iCount
         iResult = ListView_GetCheckState(hListView,i-1)
         If iResult Then
            ListView Get Text hDlg, %IDC_ListView, i, 1 To temp$
            If Len(temp$) Then
               tmp$ = tmp$ + $CrLf + Mid$(History(i), InStr(History(i),$CrLf)+2)
            End If
         End If
      Next i
      tmp$ = LTrim$(tmp$,$CrLf)
      If Len(tmp$) Then
         StopCapture = 1 : Clipboard Reset : Clipboard Set Text tmp$ : StopCapture = 0
      Else
         Beep
      End If
   Else
      ListView Get Select hDlg, %IDC_ListView To iResult
      If iResult Then
         temp$ = HistoryItemTextContainingLVLine(iResult)
         StopCapture = 1 : Clipboard Reset : Clipboard Set Text temp$ : StopCapture = 0
      Else
         Beep
      End If
   End If
End Sub

Sub DeleteItems
   If Debug Then cPrint FuncName$
   Local i,iResult,iCount,iDeleted As Long
   If UBound(History) Then
      If Ask Then
         If MsgBox ("Are you sure?", %MB_OkCancel Or %MB_IconQuestion, "Delete History Item") = %IdOk Then iResult = 1
      Else
         iResult = 1
      End If
      If iResult Then
         If ShowCheckBoxes Then
            'delete all checked
            ListView Get Count hDlg, %IDC_ListView To iCount
            For i = iCount To 1 Step -1
               iResult = ListView_GetCheckState(hListView,i-1)
               If iResult Then Array Delete History(i) : Incr iDeleted
            Next i
            If iDeleted Then
               ReDim Preserve History(UBound(History)-iDeleted)
               LoadListView
               iResult = Min(iResult,UBound(History))
               SelectFirstLineOfHistoryItem(iResult)  'select and make visible
               SaveHistory
            Else
               Beep
            End If
         Else
            'delete one selected
            ListView Get Select hDlg, %IDC_ListView To iResult   'get LV line
            If iResult Then
               iResult = HistoryItemNumberContainingLVLine(iResult) 'get History() item containing LV line
               DeleteSelectedItem
               LoadListView
               iResult = Min(iResult,UBound(History))
               SelectFirstLineOfHistoryItem(iResult)  'select and make visible
               SaveHistory
            Else
               Beep
            End If
         End If
      End If
   Else
      Beep
   End If
End Sub

Sub CPrint (SOut As String)
   Static cWritten, iCount As Long
   Incr iCount
   SOut = Format$(iCount,"000000") + "  " + SOut
   If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
   WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
End Sub

Sub CheckAll(Flag As Long)
   If Debug Then cPrint FuncName$
   Local i, iCount As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      ListView_SetCheckState hListView, i-1, Flag
   Next i
End Sub

Function InstanceTest() As Long
   If Debug Then cPrint FuncName$
   'returns 0 if instance exits or cannot create mutex. otherwise returns 1.
   Local UniqueName As WStringZ * %Max_Path, hWin As Dword
   UniqueName = "gbClipper"                     'name of mutex
   If CreateMutex(ByVal %Null, 0, UniqueName) = 0 Or GetLastError = %ERROR_ALREADY_EXISTS Then
      hWin = GeTTopWindow(%HWND_Desktop)
      Do While hWin
         If GetWindowLong(hWin, %GWL_UserData) = %UniqueNumber Then
            Function = hWin
            Exit Do
         End If
         hWin = GetWindow(hWin, %GW_HWNDNEXT)
      Loop
      ShowWindow(hWin, %SW_Restore)
      ShowWindow(hWin, %SW_Show)
      SetForegroundWindow(hWin)
      Function = 1
   End If
End Function
